////////////////////////////////////////////////////////////////////////////////
////////// ULOZENI SEZNAMU SOURADNIC I MERENI DO    *.GKF GAMA   ///////////////
#include <BK/Soubory.h>

#define PREPIS  2
void SaveGKF( SS ss, SM sm, string SFN, int flags=PREPIS )
{ fstream out;
  if( Flags(flags,PREPIS) ) out.open( SFN.c_str() ,ios_base::out);
  else out.open( SFN.c_str() ,ios_base::out|ios_base::app);

  out << "<?xml version=\"1.0\" ?>" << endl
      << "<!DOCTYPE gama-local SYSTEM \"gama-local.dtd\">" << endl
      << "<gama-xml version=\"2.0\">" << endl
      << endl
      << "<network axes-xy = \"sw\" >" << endl
      << "  <description>" << endl
      << "    Jmeno a cesta souboru: " << SFN << endl 
      << "  </description>" << endl
      << "  <parameters sigma-apr = \"1\" />" << endl
      << endl
      << "  <points-observations distance-stdev = \"10.0\" direction-stdev = \"20.0\" >" << endl << endl;

  // SEZNAM SOURADNIC
  for(SS::iterator i=ss.begin(); i!=ss.end(); i++)
  { string CB=i->first;     Bod b=i->second;
      out << "    <point id= \"" << Width(CB,0,Original|BezNul) << "\" ";
    if( b.y!=1e9999 )
      out << "y= \"" << Width(b.y,100,Delka) << "\" ";
    if( b.x!=1e9999 )
      out << "x= \"" << Width(b.x,100,Delka) << "\" ";
    if( b.z!=1e9999 )
      out << "z= \"" << Width(b.z,100,Delka) << "\" ";
      out << "adj= \"XY\"" << " />" << endl;
  }    
  out << endl;
  
  // SEZNAM MERENI (observace)  
  for(SM::iterator i=sm.begin(); i!=sm.end(); i++)
  { string CBs=i->first;
      out << "    <obs from= \"" << Width(CBs,0,Original|BezNul) << "\">" << endl;
    for(ST::iterator j=sm[CBs].begin(); j!=sm[CBs].end(); j++)
    { string CBc=Width(j->first,0,Original|BezNul);  Mereni m=j->second;
      if( m.D!=1e999 & m.D!=0 )
      { if( m.tD=='0' )out << "      <distance to= \"";
        else out << "      <s-distance to= \"";
        out << CBc << "\" " << "val= \"" << Width(m.D,100,Delka) << "\" />" << endl;
      }
      if( m.Hz!=1e999 )
        out << "      <direction to= \"" << CBc << "\" "
            << "val= \"" << Width(m.Hz,100,Uhel) << "\" />" << endl;
      if( m.Z!=1e999 & m.Z!=0 )
        out << "      <z-angle to= \"" << CBc << "\" "
            << "val= \"" << Width(m.Z,100,Uhel) << "\" />" << endl;
      if( m.h!=1e999 )
        out << "      <dh to= \"" << CBc << "\" "
            << "val= \"" << Width(m.h,100,Delka) << "\" />" << endl;
    }
    out << "    </obs>" << endl << endl;
  }
  out << "  </points-observations>" << endl << endl
      << "</network>" << endl
      << "</gama-xml>" << endl;
}

////////////////////////////////////////////////////////////////////////////////
////////// NACTENI SEZNAMU SOURADNIC I MERENI Z     *.GKF GAMA   ///////////////
//void OpenGKF( SS ss, SM sm )
//{ string OFN;     if( !GetOFN( OFN ) ) return;
//
//  chyby.clear();
//  ifstream in( OFN.c_str() );
//  
//  string s;
//  while( in >> s )
//  { if( slovo=="<point" )
//    { while( in >> s )
//      { if( s=="/>" ) break;
//        if( s=="id=" ) g
//    }
//  }
//}
